import socket
import sys
import cmefpf_pb2

HOST, PORT = "localhost", 9999

# Create a socket (SOCK_STREAM means a TCP socket)
sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)

try:
    # Connect to server
    sock.connect((HOST, PORT))
    # collect streams
    m = cmefpf_pb2.GenericRequest()
    m.type = cmefpf_pb2.GenericRequest.COLLECT_EXPIRED_STREAMS
    length = m.ByteSize()
    assert(length < (1 << 16))
    sock.send(''.join([chr(length >> 8), chr(length & 0xff)]))
    sock.send(m.SerializeToString())
    # receive response
    t = sock.recv(2)
    length = ord(t[0]) << 8 | ord(t[1])
    t = sock.recv(length)
    r = cmefpf_pb2.GenericResponse.FromString(t)
    print("Received:")
    print(str(r))
    # send configure stream
    for i in range(1,10):
        m = cmefpf_pb2.GenericRequest()
        m.type = cmefpf_pb2.GenericRequest.CONFIGURE_STREAM
        m.configure.id = i
        m.configure.filter.ip_source = "1.1.1.1"
        m.configure.filter.ip_destination = "2.2.2.2"
        m.configure.filter.protocol = 6
        m.configure.filter.port_source = 80
        m.configure.filter.port_destination = 0
        m.configure.bandwidth = 1000
        m.configure.cos = "PR"
        m.configure.key = "\x01\x02{0:c}".format(i & 0xff)
        m.configure.refresh_time = 10
        m.configure.as_path.extend([1,2,3])
        length = m.ByteSize()
        assert(length < (1 << 16))
        sock.send(''.join([chr(length >> 8), chr(length & 0xff)]))
        sock.send(m.SerializeToString())
        # receive response
        t = sock.recv(2)
        length = ord(t[0]) << 8 | ord(t[1])
        t = sock.recv(length)
        r = cmefpf_pb2.GenericResponse.FromString(t)
        print("Received:")
        print(str(r))
finally:
    sock.close()

