/*
 * FPF implementation.
 * 2013 @ Jaroslaw Sliwinski &  Piotr Wisniewski
 */
#ifndef CF_CONFIG_H
#define CF_CONFIG_H

#include <linux/if_ether.h>

struct cf_forwarding_entry {
	int type;
#define CF_NONE 0
#define CF_ETHERNET 1
#define CF_VLAN 2
#define CF_DEVICE 3
	struct net_device *dev;
	uint8_t dst_ethernet[ETH_ALEN];
	uint16_t vlan_tag;
	size_t byte_count;
	size_t packet_count;
};

extern int cf_create_config(void);
extern void cf_destroy_config(void);

extern struct cf_forwarding_entry *cf_get_fentry(uint8_t key);
extern int cf_create_fentry_ethernet(uint8_t key, char *if_name, uint8_t *dst_ethernet);
extern int cf_create_fentry_vlan(uint8_t key, char *if_name, uint8_t *dst_ethernet, uint16_t vlan_tag);
extern int cf_create_fentry_device(uint8_t key, char *if_name);
extern int cf_remove_fentry(uint8_t key);


#endif /* CF_CONFIG_H */
