/*
 * FPF implementation.
 * 2013 @ Jaroslaw Sliwinski &  Piotr Wisniewski
 */
/* Piotrek W. patch: next line added for compapility with openSuse 12.2 */
#include <linux/module.h>

#include <linux/kernel.h>
#include <linux/init.h>

MODULE_LICENSE("GPL");
MODULE_AUTHOR("Jaroslaw Sliwinski    Piotr Wisniewski");
MODULE_DESCRIPTION("FPF forwarder");

#include "cf_config.h"
#include "cf_netlink.h"
#include "cf_protocol.h"

uint8_t dst_mac[] = {0xaa, 0xbb, 0xcc, 0x01, 0x02, 0x03};

static int __init cf_init(void)
{
	printk(KERN_INFO "FPF forward: starting\n");
	if (cf_create_config() < 0)
	{
		printk(KERN_WARNING "FPF forward: unable to create configuration\n");
		goto error0;
	}
	if (cf_register_netlink() < 0)
	{
		printk(KERN_WARNING "FPF forward: unable to register netlink\n");
		goto error1;
	}
	if (cf_register_protocol() < 0)
	{
		printk(KERN_WARNING "FPF forward: unable to register protocol\n");
		goto error2;
	}
	return 0;
error2:
	cf_deregister_netlink();
error1:
	cf_destroy_config();
error0:
	return -ENOMEM;
}

static void __exit cf_exit(void)
{
	printk(KERN_INFO "FPF forward: closing\n");
	cf_deregister_protocol();
	cf_deregister_netlink();
	cf_destroy_config();
}

module_init(cf_init);
module_exit(cf_exit);
