/*
 * FPF implementation.
 * 2013 @ Jaroslaw Sliwinski  &  Piotr Wisniewski
 */
#ifndef CI_NETLINK_H
#define CI_NETLINK_H

enum {
	CI_ATTR_UNSCPEC,
	CI_ATTR_ID,
	CI_ATTR_TIMEOUT,
	CI_ATTR_SRC_ADDRESS_IPV4,
	CI_ATTR_DST_ADDRESS_IPV4,
	CI_ATTR_SRC_ADDRESS_IPV6,
	CI_ATTR_DST_ADDRESS_IPV6,
	CI_ATTR_PROTOCOL,
	CI_ATTR_SRC_PORT,
	CI_ATTR_DST_PORT,
	CI_ATTR_KEY,
	CI_ATTR_KEY_LENGTH,
	__CI_ATTR_MAX,
};

#define CI_ATTR_MAX (__CI_ATTR_MAX - 1)

#define CI_KEY_SIZE 128

enum {
	CI_CMD_ADD_ENTRY_IPV4,
	CI_CMD_REMOVE_ENTRY_IPV4,
	CI_CMD_ADD_ENTRY_IPV6,
	CI_CMD_REMOVE_ENTRY_IPV6,
	CI_CMD_COLLECT_ENTRIES,
};

enum {
	CI_RESPONSE_ATTR_UNSPEC,
	CI_RESPONSE_ATTR_ID,
	CI_RESPONSE_ATTR_BYTES,
	CI_RESPONSE_ATTR_DURATION,
	__CI_RESPONSE_ATTR_MAX,
};

#define CI_RESPONSE_ATTR_MAX (__CI_RESPONSE_ATTR_MAX - 1)

extern int ci_register_netlink(void);
extern void ci_deregister_netlink(void);

#endif /* CI_NETLINK_H */
