/*
 * FPF implementation.
 * 2013 @ Jaroslaw Sliwinski &  Piotr Wisniewski
 */
#ifndef CI_STORE_H
#define CI_STORE_H

#include <linux/types.h>

struct expired_stream
{
	struct list_head list;
	uint32_t id;
	uint64_t byte_count;
	uint32_t duration;
};

extern int ci_create_store(void);
extern void ci_destroy_store(void);

extern int ci_add_entry_ipv4(uint32_t id, unsigned long timeout,
			     uint8_t *src_address, uint8_t *dst_address,
			     uint8_t protocol,
			     uint16_t src_port, uint16_t dst_port,
			     char *key, size_t key_length);

extern int ci_find_entry_ipv4(uint8_t *ip_header, size_t byte_count,
			      uint32_t *id, char **key, size_t *key_length);


extern int ci_remove_entry_ipv4(uint32_t id,
				uint8_t *src_address, uint8_t *dst_address);

extern int ci_add_entry_ipv6(uint32_t id, unsigned long timeout,
			     uint8_t *src_address, uint8_t *dst_address,
			     uint8_t protocol,
			     uint16_t src_port, uint16_t dst_port,
			     char *key, size_t key_length);

extern int ci_find_entry_ipv6(uint8_t *ip_header, size_t byte_count,
			      uint32_t *id, char **key, size_t *key_length);

extern int ci_remove_entry_ipv6(uint32_t id,
				uint8_t *src_address, uint8_t *dst_address);

extern void ci_fetch_expired_streams(struct expired_stream *exs);

#endif /* CI_STORE_H */
